com.holonplatform.core.query

## Interface QueryConfigurationProvider.Builder

- Enclosing interface:
    QueryConfigurationProvider

      public static interface QueryConfigurationProvider.Builder

  Builder to create `QueryConfigurationProvider` instances.
  Since:
    5.2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `QueryConfigurationProvider` | `build()` Build the `QueryConfigurationProvider` instance.
    `QueryConfigurationProvider.Builder` | `filter(QueryFilter filter)` Add a `QueryFilter`.
    `<T> QueryConfigurationProvider.Builder` | `parameter(ConfigProperty<T> property, T value)` Add a query parameter using a `ConfigProperty` and `ConfigProperty.getKey()` as parameter name.
    `QueryConfigurationProvider.Builder` | `parameter(String name, Object value)` Add a query parameter.
    `QueryConfigurationProvider.Builder` | `sort(QuerySort sort)` Add a `QuerySort`.

- - ### Method Detail

    - #### filter

          QueryConfigurationProvider.Builder filter(QueryFilter filter)

      Add a `QueryFilter`.

      If a filter was already added, the given filter will be added to the previous ones using the AND logical operator.

      Parameters:
        `filter` - The `QueryFilter` to add (not null)
      Returns:
        this

    - #### sort

          QueryConfigurationProvider.Builder sort(QuerySort sort)

      Add a `QuerySort`.

      If one or more sort is already present, the given sort will be appended to the sort list.

      Parameters:
        `sort` - The `QuerySort` to add (not null)
      Returns:
        this

    - #### parameter

          QueryConfigurationProvider.Builder parameter(String name,
                                                       Object value)

      Add a query parameter.
      Parameters:
        `name` - Parameter name (not null)
        `value` - Parameter value
      Returns:
        this

    - #### parameter

          <T> QueryConfigurationProvider.Builder parameter(ConfigProperty<T> property,
                                                           T value)

      Add a query parameter using a `ConfigProperty` and `ConfigProperty.getKey()` as parameter name.
      Type Parameters:
        `T` - Config property type
      Parameters:
        `property` - The configuration property (not null)
        `value` - Configuration property value
      Returns:
        this

    - #### build

          QueryConfigurationProvider build()

      Build the `QueryConfigurationProvider` instance.
      Returns:
        The `QueryConfigurationProvider` instance

Copyright © 2019 The Holon Platform. All rights reserved.